// VERILOG_proz_vars.PNG     REVISION HISTORY 
// Version          : 1.1 
// Author(s)        : Holger 
// Mod. Date        : Dez 17, 2012
// Changes Made     : wb_Write_export_via_rNULL. 
//                     if( export / import ) begin: NAME_DEFINITIONS 
// ============================================================================= 
`include "timescale.v"          // REG4  EXPORT;  REG4  IMPORT ;
`define wbSIMPLEX_Fast_Link_ADDR_BUS_SIZE (2) // wide 8Bit cut_off in Instanciation to 2bit wide 
`define CNT_SIZE 32
 // .S1_BASE (4'h10) // [TIMER]  
module uuptime_wb(clk_ii,rst_i,wb_dat_i_fabi, wb_adr_ii  , wb_dat_single_as_sampler_o  , wb_cyc_i,wb_stb_i,wb_we_i,wb_ack_o );
// PANCAKE STACK  reg4 ------------------------------------------reg_r0 TOP-OF STACK --TOS 
 parameter CLK_IN_HZ = 1; // ???
  input                      clk_ii; // TIMER clock_iirq 
  input                      rst_i;
  input                [7:0] wb_dat_i_fabi;  // newFabitio
  input  [`wbSIMPLEX_Fast_Link_ADDR_BUS_SIZE-1:0] 
                             wb_adr_ii ; // ADDR case 0,1,2,(3-is#notUsed)-FLIP00
  output               [7:0] wb_dat_single_as_sampler_o ; // wb_DATA_OUTPUT_PORT as 8Bit_
  /*---------------------------------------------------------*/
  input                      wb_cyc_i;  // 3
  input                      wb_stb_i; //  2
  input                      wb_we_i;  //  1
  output                     wb_ack_o; //  0 ~~~|~flip_I-I-Nverter (i/4) %4 
//######### PANCAKE STACK  ###############################################
// Define: some Registers + Trigger Reg.
   reg sec_clock_irq_trigger; // Flip-Flop alle halbe Sekunde Send_Event 
 //   Arbeits-Register fr current running ticks 
  reg [7:0] seconds_cur_work_reg_00;
  reg [7:0] minutes_cur_work_reg_01;
  reg [7:0]   hours_cur_work_reg_02;
 //  Schatten-Register zum auffangen der current running ticks 
 // Arbeits-Register als Freeze-Latches 
 // wenn der Wishbone Bus Read + Cycle Strobe usw. 'triggert 
  reg [7:0] shaddow_00_seconds_reg;
  reg [7:0] shaddow_01_minutes_reg;
  reg [7:0] shaddow_02_hours_reg;
  // Ende shaddow 
   reg [7:0] dat_o_reg_single_4; //  Hilfs Register 
// ### working first assign step:
// #####################################
 //
 //-------<<<<<<------------------------------------------------------------------
 assign wb_dat_single_as_sampler_o = dat_o_reg_single_4;  // <<<assign a single Freezed-Timer values 
                                        // via case wb_Addr_i-Compare-Match  
 // if  (wb_adr_ii == ??? shaddow_reg ) 
 // dat_o_reg_single_4  <(:)--shaddow_00_seconds_reg;
 // assign (wb_dat_single_as_sampler_o) <-- dat_o_reg_single_4
 //-------------------------------------------------------------------------------
 
 // Hint: Der WishBone Bus is bei 'Read aktiv("Low")<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
//####################################### 
wire wb_tigger_flg[2-1:0];  // Flag as a 2BitSpur 
  // Anpassbar auf "negierten" Bus Slave z.B Fabitio CAN 
  localparam wb_Write_export_via_rNULL = (0);
  localparam wb_Read_import_via_r4    =  (1);
 // ack HANDSHAKE stretch  Return via "tatham__0 co_routine_flg" ? : (wb_stb_i && 1'b1 ) (wb_stb_i && done ) 
 assign wb_ack_o =   wb_stb_i; // Reflect 1_later clk-cycle  ??? mirror reflect wb_stb_iInput--to wb_ack_oOutput bingo.
 // #### Ende ack HANDSHAKE
 
 // Hier die Gleichung fr Anpassung Reg: r0 , r4 --> via export/import 
  // to do on Export_reg_r0_#NULL, to do on Import_reg04_#four
                                                  // con_catination assignment 
 assign  wb_tigger_flg[wb_Write_export_via_rNULL] =(wb_we_i & wb_stb_i & wb_cyc_i );
                                               //  (wb_we_i && wb_stb_i && wb_cyc_i ); 
 //assign  wb_tigger_flg[ wb_Read_import_via_r4]    =  (~|wb_tigger_flg[wb_Write_export_via_rNULL]); 
 assign  wb_tigger_flg[ wb_Read_import_via_r4]    =  (~wb_tigger_flg[wb_Write_export_via_rNULL]); 
                               // u. via <SIMPLEX> Addr:Bus as Single selection 
// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           // See: Lothar Miller Clock-Stuff:  
   localparam DIVISOR_62_5 = 31249999; // CLK_IN_HZ Base_clk @62.500000 Mhz
  /* (clock /2) -1)  */
   // NOTE: CNT_SIZE must be set large enough 
  reg [`CNT_SIZE-1:0] tick_clock_count;
  
// Command go Freeze: response to "export r0,0x00"
//   Task(#4)
always@(posedge clk_ii or posedge rst_i) begin : SHADDOW_ALWAYS //
    if (rst_i) begin
      shaddow_00_seconds_reg <= 0;
      shaddow_01_minutes_reg <= 0;
      shaddow_02_hours_reg   <= 0;
    end
    else begin /* ?_FRREZE working_regs in shaddow_regs */
   		  if( wb_tigger_flg[ wb_Write_export_via_rNULL ] ) begin : SHADDOW_ALWAYS_FREEZE //
	       shaddow_00_seconds_reg <= seconds_cur_work_reg_00; /* always copy_ing working-tick<-r to shaddow_register*/
           shaddow_01_minutes_reg <= minutes_cur_work_reg_01; // expl. Minutes:_cur_work_reg_01;//minutes;
           shaddow_02_hours_reg   <=   hours_cur_work_reg_02;
      end
    end
 
 end
  // Distribute: Single Freezed shaddow_regs via <SIMPLEX> Addr:Bus to: dat_o_reg_single_4
//   Task(#3) response to Command "import r4, 0x02"  
  always@(posedge clk_ii or posedge rst_i) begin : ADDR_MAIN_CASE
    if (rst_i) begin
      dat_o_reg_single_4 <= 0;
    end
    else begin
      if( wb_tigger_flg[ wb_Read_import_via_r4 ] )begin : via_ADDR_CASE_put  // 
	  case ( wb_adr_ii ) // case single select via <SIMPLEX> Addr:Bus 
  		 'h2: dat_o_reg_single_4 <= shaddow_02_hours_reg; 
	      'h1: dat_o_reg_single_4 <= shaddow_01_minutes_reg;
	      'h0: dat_o_reg_single_4 <= shaddow_00_seconds_reg;
          // Hint: c_store to a single byte store wb_dat_single_as_sampler_o ,later via  
		  // assign wb_dat_single_as_sampler_o = dat_o_reg_single_4; 
		 default: dat_o_reg_single_4 <= shaddow_00_seconds_reg;
        endcase
      end
    end 
  end
   
 /* 'Eevent toggle-FLIP     */   
 // ##########<<<<<<<######<<<<<<<<<#########################################
 // UHR:_HH_MM_SS_Sekunden_Ticks_Task(#2): ( 'event--- )  
 always@( posedge sec_clock_irq_trigger or posedge rst_i) begin : CLOCK_DIVIDE_MANAGER //
    if (rst_i) begin
         hours_cur_work_reg_02 <= (0);
       minutes_cur_work_reg_01 <= (0);
       seconds_cur_work_reg_00 <= (0);
    end
    else begin : Wire_Get_05_ticks_flip_Message 
      if (seconds_cur_work_reg_00[7:0] < 59)  begin //59
        seconds_cur_work_reg_00 <= (seconds_cur_work_reg_00) + 1; // Inc Sekunden
      end
      else begin
		   minutes_cur_work_reg_01 <= (minutes_cur_work_reg_01) + 1; // Inc Minuten
		   seconds_cur_work_reg_00[7:0] <= (0); // seconds housekeeping to prevent Overflow 
           
        if (minutes_cur_work_reg_01[7:0] > 58) begin //59-1
            minutes_cur_work_reg_01[7:0] <= 0; // minutes housekeeping prevent Overflow
            hours_cur_work_reg_02 <= (hours_cur_work_reg_02) + 1;  // Inc Stunden 
        end
      end
    end
  end
 
 // ##########<<<<<<<######<<<<<<<<<#########################################
 // Halbe_Sekunden_Ticks_Task(#1): (--- 'event )  
    /* "Post a Message a message every half second  */ 
//----------------------------
// virtual Counter --__--o EVENT Info
// Clock Generator 
//-----------------------------
 always@(posedge clk_ii or posedge rst_i) begin : CLOCK_1Sek_ev_Generator // 
    if (rst_i) begin
      sec_clock_irq_trigger <= (0);
      tick_clock_count <= (0);
    end
    else begin
	 if (tick_clock_count < DIVISOR_62_5) begin
         tick_clock_count <= tick_clock_count + 1; // inc 
      end
      else begin
        tick_clock_count <= 0; // housekeeping overflov preventer
		// EVENT Info negate not ! bit
		//  sec_clock_irq_trigger <= (~|sec_clock_irq_trigger); // bitflip_not to toggle the trigger 
        sec_clock_irq_trigger <= (!sec_clock_irq_trigger); // flip_not to toggle the trigger 
      end 
    end
  end
 // #######################
 // Ende der Modules 
 //########################
 endmodule
 /* ########### ENDE of uptime_wb.v ######*/

///////////////////////////////// E O F ////////////////////////////////////